####################
###simulation 5.1###
####################
#data generation

library(vegan)
source('Functions.R')

data(varechem)
varenew<-varechem[,c(1,2,7,14)]
a.temp<-within(varenew,{
	pH.n<-(pH-mean(pH))/sd(pH)
		Al.n<-(Al-mean(Al))/sd(Al)
			P.n<-(P-mean(P))/sd(P)
				N.n<-(N-mean(N))/sd(N)
	#return(cbind(N.n,P.n,Al.n,pH.n))
})
b.temp<-within(a.temp,{
	z1<-N.n-P.n
})
c.temp<-within(b.temp,{
	res<-apply(b.temp[,5:8],2,function(x) lm(x~z1)$residuals)
})
z2<-c.temp$res%*%c(0,0,1,-1)
z1<-b.temp$z1
x.m<-cbind(b.temp$N.n,b.temp$P.n,b.temp$Al.n,b.temp$pH.n)
colnames(x.m)<-c('N','P','Al','pH')
rownames(x.m)<-1:24

sst<-replicate(1000,{
y1<-matrix(rpospois(480,lambda=30-(z1-2)^2),24,20)
y2<-matrix(rpospois(480,lambda=30-(z1+2)^2),24,20)
y3<-matrix(rpospois(240,lambda=30-(z2-2)^2),24,10)
y4<-matrix(rpospois(240,lambda=30-(z2+2)^2),24,10)  
rowid<-0
yy<-cbind(y1,y2,y3,y4)
yy2<-yy
yy2[rowid,]<-0
bb<-matrix(rbinom(1440,1,0.3),24,60)
y1<-yy2*bb
y1[rowid,]<-yy[rowid,]

      (A1<-nlm(LR,c(1,-1,0,0),sp=y1,envar=x.m,TYPE='pps',gradtol = 1e-4,steptol = 1e-4))
 		at1<-A1$estimate
 		cd1<-A1$code
 		B1<-nlm(LR_pois,c(1,-1,0,0),sp.new=y1,envar=x.m,gradtol = 1e-4,steptol = 1e-4)
 		C1<-cca(y1~x.m)
 		
 		ap1<-B1$estimate
 		cd2<-B1$code
            at11<-at1/sqrt(sum(at1^2))
            ap11<-ap1/sqrt(sum(ap1^2))
        
 		site11<-x.m%*%at11
 		site12<-x.m%*%ap11
 		
		res1<-apply(x.m,2,function(x) {lm(x~site11)$residuals})
		res2<-apply(x.m,2,function(x) {lm(x~site12)$residuals})
		
		A2<-nlm(LR,c(0,0,1,-1),sp=y1,envar=res1,TYPE='pps',gradtol = 1e-4,steptol = 1e-4)
		at2<-A2$estimate
		cd3<-A2$code
		B2<-nlm(LR_pois,c(0,0,1,-1),sp.new=y1,envar=res2,gradtol = 1e-4,steptol = 1e-4)
		C2<-cca(y1~res2)
		ap2<-B2$estimate
		cd4<-B2$code
		at12<-at2/sqrt(sum(at2^2))
		ap12<-ap2/sqrt(sum(ap2^2))
		site21<-res1%*%at12
		site22<-res2%*%ap12
    return(list('A1'=A1,'B1'=B1,'A2'=A2,'B2'=B2,'Y'=y1,'X'=x.m, 'Site11'=site11,'Site12'=site12,'Site21'=site21,'Site22'=site22))
})

#load('~/Dropbox/antonov/sst0.Rda')
#load('~/Dropbox/antonov/sst3.Rda')
#load('~/Dropbox/antonov/sst4.Rda')

sstf<-cbind(sst3,sst4,sst0)
schem1.ztp1<-latexTable(sstf[1,])
sd1<-schem1.ztp1[,2]
schem1.ztp2<-latexTable(sstf[3,])
sd2<-schem1.ztp2[,2]
schem1.p1<-latexTable(sstf[2,])
schem1.p2<-latexTable(sstf[4,])
ta<-lapply(sstf[4,],function(x) x$code)
id<-which(ta==1)
library(xtable)
xtable(cbind(schem1.ztp1,schem1.ztp2,schem1.p1,schem1.p2),digits=4)

#ordination diagram#
vnorm<-function(x){
  es<-x[[1]]$estimate
  es/sqrt(sum(es^2))
}
#
zt<-cbind(vnorm(sst0[1,k]),vnorm(sst0[3,k]))
zp<-cbind(vnorm(sst0[2,k]),vnorm(sst0[4,k]))
st<-cbind(targ$Site11,targ$Site21)
sp<-cbind(targ$Site12,targ$Site22)
#############################
par(mfrow=c(1,2),mar = .1+ c(2,2,2,1))
pdf('~/Desktop/sim1hztp.PDF')
mybiplot1(st,zt,col='black',cex=c(0.7,0.9),xlim=c(-3,3),ylim=c(-3,3),xlab='1st Environmental gradeint',ylab='2nd Environmental gradient',main='HZTP')
points(cbind(mT1,mT2)/3,col=rep(c('red','blue','darkgreen','grey40'),c(20,20,10,10)),pch=rep(1:4,c(20,20,10,10)),cex=0.7)
legend(0.8,1,c('Sp. 1-20', 'Sp. 21-40', 'Sp. 41-50', 'Sp. 51-60'),pch=1:4,col=c('red','blue','darkgreen','grey40'),cex=0.7,bg='grey90')
dev.off()
#####
pdf('~/Desktop/sim1p.PDF')
mybiplot1(sp,zp,col='black',cex=c(0.7,0.9),,xlim=c(-3,3),ylim=c(-3,3),xlab='1st Environmental gradeint',ylab='2nd Environmental gradient',main='Poisson')
points(cbind(mP1,mP2)/3,col=rep(c('red','blue','darkgreen','grey40'),c(20,20,10,10)),pch=rep(1:4,c(20,20,10,10)),cex=0.7)
legend(0.9,1,c('Sp. 1-20', 'Sp. 21-40', 'Sp. 41-50', 'Sp. 51-60'),pch=1:4,col=c('red','blue','darkgreen','grey40'),cex=0.7,bg='grey90')
dev.off()

mybiplot1(st,zt,col='black',cex=c(0.7,0.7),xlim=c(-3,3),ylim=c(-3,3))
points(cbind(mT1,mT2)/3,pch=rep(1:4,c(20,20,10,10)))
mybiplot1(sp,zp,col='black',cex=c(0.7,0.7),,xlim=c(-3,3),ylim=c(-3,3))
points(cbind(mP1,mP2)/2,col=rep(c('red','blue','green','pink'),c(20,20,10,10)),pch=19)

#apply CCA to the same type of data

sstf1<-sstf[,id]

rowSums(test1)/1019
test1<-apply(test,1,function(x) x/sqrt(sum(x^2)))
test<-matrix(unlist(cca.simu1),ncol=4,byrow=T)

cca.simu1<-lapply(sstf1[5,],function(x) coef(cca(x~x.m))[,1])
cca.simu2<-lapply(sstf1[5,],function(x) coef(cca(x~x.m))[,2])

cca11<-matrix(unlist(cca.simu1),ncol=4,byrow=T)
cca12<-matrix(unlist(cca.simu2),ncol=4,byrow=T)

cca11<-apply(cca11,1,function(x) x/sqrt(sum(x^2)))
cca12<-apply(cca12,1,function(x) x/sqrt(sum(x^2)))

cca1<-rowSums(cca11)/1019
cca2<-rowSums(cca12)/1019
cca1.sd<-apply(cca11,1,sd)
cca2.sd<-apply(cca12,1,sd)

#figure 1
target<-sst0[,96]
ty<-target$Y
tx<-target$X

dim(ty)
rownames(ty)<-1:24
colnames(ty)<-1:60
rownames(tx)<-1:24
colnames(tx)<-c('var1','var2','var3','var4')
cca.example<-cca(ty~tx)
plot(cca.example)
rownames(ss$biplot)<-c('var1','var2','var3','var4')

pdf('~/Dropbox/homework/CCASim1Biplot.pdf')
mybiplot1(ss$sites,ss$biplot,col='black',cex=c(0.7,0.7),xlim=c(-10,10),ylim=c(-10,10))
points(ss$species/3,col=rep(c('red','blue','darkgreen','grey40'),c(20,20,10,10)),pch=rep(1:4,c(20,20,10,10)),cex=0.5)
legend(0.7,1,c('Sp. 1-20', 'Sp. 21-40', 'Sp. 41-50', 'Sp. 51-60'),pch=1:4,col=c('red','blue','darkgreen','grey40'),cex=0.5,bg='grey90')
dev.off()

xtable(cbind(schem1.ztp1,schem1.ztp2,schem1.p1,schem1.p2,cca1,cca1.sd,cca2,cca2.sd),digits=4)

#figure 2#
ztpmean<-cbind(schem1.ztp1[,1],schem1.ztp2[,1])
ztpsd<-cbind(schem1.ztp1[,2],schem1.ztp2[,2])
ztpsite<-x.m%*%ztpmean
mybiplot1(ztpsite,ztpmean,ztpsd,cex=c(0.5,0.9,1,1),xlim=c(-3,3),ylim=c(-3,3),far=c(1.3,1.4),xlab='1st Environmental gradient',ylab='2nd Environmental gradient')
points(opt.all[,c(1,5)],cex=0.4,pch=1,col='green')
points(opt.all[,c(2,6)],cex=0.4,pch=1,col='red')
points(opt.all[,c(3,7)],cex=0.4,pch=1,col='blue')
points(opt.all[,c(4,8)],cex=0.4,pch=1,col='pink')
###############
dev.off()

opt.all<-matrix(nrow=1019,ncol=8)
for(j in 1:length(sstf1)){
  temp<-sstf1[,j]
  spec<-spec.log<-temp$Y[,c(1,25,45,55)]
  #spec.log[spec!=0]<-log(spec[spec!=0])
  coef1<-apply(spec.log,2,function(x) ZT_posnegb(x,temp$Site11,model='pps')$coefficients)
  opt1<--coef1[2,]/(2*coef1[3,])
  coef2<-apply(spec.log,2,function(x) ZT_posnegb(x,temp$Site21,model='pps')$coefficients)
  opt2<--coef2[2,]/(2*coef2[3,])
  opt.all[j,]<-cbind(opt1,opt2)
}

opt.all<-opt.all[1:1006,]
apply(sstf1[,1]$Y[,1:3],2,function(x) ZT_posnegb(x~sstf1[,1]$Site11+I(sstf1[,1]$Site11^2)$coefficients))
ZT_posnegb(sstf1[,1]$Y[,1],sstf1[,1]$Site11,model='pps')$coefficients

pdf('~/Desktop/sim1ztp.pdf')
par(mai=c(1,1,2,2))
plot(-5:5,-5:5,type='n',xlab="",ylab="")
points(opt.all[,c(1,5)],cex=0.8,pch=19,col='lightgreen')
points(opt.all[,c(2,6)],cex=0.8,pch=2,col='red')
points(opt.all[,c(3,7)],cex=0.8,pch=3,col='blue')
points(opt.all[,c(4,8)],cex=0.8,pch=6,col='grey50')
abline(v=0,h=0,lty=3)
par(mai=c(4,4,1,1))
par(new=TRUE)
mybiplot1(ztpsite,ztpmean,ztpsd,cex=c(0.5,0.9,1,1),xlim=c(-3,3),ylim=c(-3,3),far=c(1.3,1.4),col='blue',xlab='',ylab='')
dev.off()

##Poisson###

opt.all.Poisson<-matrix(nrow=1019,ncol=8)
for(j in 1:length(sstf1)){
  temp<-sstf1[,j]
  spec<-spec.log<-temp$Y[,c(1,25,45,55)]
  #spec.log[spec!=0]<-log(spec[spec!=0])
  Pcoef1<-apply(spec.log,2,function(x) glm(x~temp$Site12+I(temp$Site12^2),family='poisson')$coefficients)
  Popt1<--Pcoef1[2,]/(2*Pcoef1[3,])
  Pcoef2<-apply(spec.log,2,function(x) glm(x~temp$Site22+I(temp$Site22^2),family='poisson')$coefficients)
  Popt2<--Pcoef2[2,]/(2*Pcoef2[3,])
  opt.all.Poisson[j,]<-cbind(Popt1,Popt2)
}
opt.all.Poisson<-opt.all.Poisson[1:1007,]

pmean<-cbind(schem1.p1[,1],schem1.p2[,1])
psd<-cbind(schem1.p1[,2],schem1.p2[,2])
psite<-x.m%*%pmean

pdf('~/Desktop/sim1Poisson.pdf')
par(mai=c(1,1,2,2))
plot(-5:5,-5:5,type='n',xlab="",ylab="")
points(opt.all.Poisson[,c(1,5)],cex=0.8,pch=19,col='lightgreen')
points(opt.all.Poisson[,c(2,6)],cex=0.8,pch=2,col='red')
points(opt.all.Poisson[,c(3,7)],cex=0.8,pch=3,col='blue')
points(opt.all.Poisson[,c(4,8)],cex=0.8,pch=6,col='grey50')
abline(v=0,h=0,lty=3)
par(mai=c(4,4,1,1))
par(new=TRUE)
mybiplot1(psite,pmean,psd,cex=c(0.5,0.9,1,1),xlim=c(-3,3),ylim=c(-3,3),far=c(1.6,1.6),col='blue',xlab='',ylab='')
dev.off()

#cca#

cca.sp1<-lapply(sstf1[5,],function(x) summary(cca(x~x.m))$specie[c(1,25,45,55),1])
cca.sp2<-lapply(sstf1[5,],function(x) summary(cca(x~x.m))$specie[c(1,25,45,55),2])
cca.spec1<-matrix(unlist(cca.sp1),ncol=4,byrow=T)
cca.spec2<-matrix(unlist(cca.sp2),ncol=4,byrow=T)
cca.spec<-cbind(cca.spec1,cca.spec2)

cca.mean<-cbind(cca1,cca2)
cca.site<-x.m%*%cca.mean
rownames(cca.mean)<-c('Var 1','Var 2','Var 3','Var 4')

pdf('~/Desktop/sim1CCA.pdf')
par(mai=c(1,1,2,2))
plot(-1.5:1.5,-1.5:1.5,type='n',xlab="",ylab="")

points(cca.spec[,c(3,7)],cex=0.8,col='blue',pch=3)
points(cca.spec[,c(4,8)],cex=0.8,col='grey50',pch=6)
points(cca.spec[,c(1,5)],cex=0.8,col='lightgreen',pch=19)
points(cca.spec[,c(2,6)],cex=0.8,col='red',pch=2)

abline(v=0,h=0,lty=3)
par(mai=c(4,4,1,1))
par(new=TRUE)
mybiplot1(cca.site,cca.mean,sdd=cbind(cca1.sd,cca2.sd),cex=c(0.5,0.9,1,1),xlim=c(-3,3),ylim=c(-3,3),far=c(1.6,1.6),col='blue',xlab='',ylab='')
dev.off()

####################
###simulation 5.2###
####################

#read in the result of the simulated data

best.all<-cbind(best4,best5,best6,best7,best8,best9,best10,best11)

ztp.ztp1<-lapply(best.all[4,],function(x) x['code'])
ztp.ztp2<-matrix(unlist(ztp.ztp1),nrow=1000,ncol=13,byrow=TRUE)
ztp.ztp<-apply(ztp.ztp2,1,function(x) x/sqrt(sum(x^2)))

rowSums(ztp.ztp)/1000

load('Enva.Rda')
#####
afAna<-function(DatPar,main,nameG){
id<-which(is.na(DatPar))
if (length(id)==0){DatPar<-DatPar}
else (DatPar<-DatPar[-id])
ztp.ztp1<-lapply(DatPar,function(x) x['estimate'])
ztp.ztp2<-matrix(unlist(ztp.ztp1),nrow=1000-length(id),ncol=13,byrow=TRUE)
ztp.ztp<-apply(ztp.ztp2,1,function(x) x/sqrt(sum(x^2)))#13x1000
#AvePar<-rowSums(ztp.ztp)/1000
varS<-apply(ztp.ztp,1,function(x) sd(x))
return(varS)
#return(AvePar)
	}

ztp.ztp1<-lapply(best.all[3,],function(x) x['estimate'])
ztp.ztp2<-matrix(unlist(ztp.ztp1),nrow=1000-length(id)*0,ncol=13,byrow=TRUE)
ztp.ztp<-apply(ztp.ztp2,1,function(x) x/sqrt(sum(x^2)))#13x1000


load('~/a_ini.Rda')
a1<-afAna(best.all[3,],main='',nameG='ztpP')
a2<-afAna(best.all[4,],nameG='LRR-ZTP',main='')
b1<-afAna(best.all[5,],nameG='ztnbP',main='')
b2<-afAna(best.all[6,],nameG='ztnbZTP',main='')
a3<-afAna(ztp.zip,nameG='ztpZIP',main='')
b3<-afAna(ztnb.zip,nameG='ztnbZIP',main='')

cc<-lapply(ztp.zip,function(x) x['estimate'])
matrix(unlist(cc),nrow=1000-length(id),ncol=13)

which(is.na(ztp.zip))
ztp.zip[400]
load('/Users/yingjiezhang/Dropbox/antonov/a_ini.Rda')
load('final.Rda')

eg1.p<-t(t(ztp.p)%*%t(Enva))
eg1.ztp<-t(t(ztp.ztp)%*%t(Enva))
dim(zz)

apply(best.all[1,1][[1]],2,function(x) glm(x~eg1.p[,1]+I(eg1.p[,1]^2),family='poisson')$coefficients)

beta.p<-array(NA,c(3,100,1000))
for(i in 1:1000){
	beta.p[,,i]<-apply(best.all[1,i][[1]],2,function(x) glm(x~eg1.p[,i]+I(eg1.p[,i]^2),family='poisson')$coefficients)
	}
	
	library(snowfall)
	source('/Users/yingjiezhang/Dropbox/antonov/Functions.R')
	
beta.ztp<-array(NA,c(3,100,1000))
for(i in 1:1000){
	beta.ztp[,,i]<-tryCatch({test<-apply(best.all[1,i][[1]],2,function(x) ZT_posnegb(x,eg1.ztp[,i],model='pps')$coefficients)},error=function(e) {return(NA)})
	}	

AveBeta.p<-apply(beta.p,1:2,function(x) sum(x))/1000
AveBeta.ztp<-apply(beta.ztp[,,-id],1:2,function(x) sum(x))/987

betas<-cbind(bb0[1,],bb1[1,],bb2[1,],t(AveBeta.p),t(AveBeta.ztp))
colnames(betas)<-c('beta0','beta1','beta2','P_beta0','P_beta1','P_beta2','ZTP_beta0','ZTP_beta1','ZTP_beta2')

id<-which(is.na(colSums(beta.ztp[1,,])))

save(best.all,ztp.zip,ztnb.zip,eg1.p,eg1.ztp,betas,beta.p,beta.ztp,file='final2.Rda')
##########################
library(vegan)
ttest<-cca(best.all[1,1][[1]],Enva)
summary(ttest)
axe1.ztplist<-lapply(best.all[1,],function(x) coef(cca(x,Enva))[,1])
axe1.ztpmatrix<-matrix(unlist(axe1.ztplist),ncol=13,byrow=T)
axe1.ztp<-apply(axe1.ztpmatrix,1,function(x) x/sqrt(sum(x^2)))
a4<-rowSums(axe1.ztp)/1000
a4.sd<-apply(axe1.ztp,1,sd)
####HZNB data####
axe1.ztnblist<-lapply(best.all[2,],function(x) coef(cca(x,Enva))[,1])
axe1.ztnbmatrix<-matrix(unlist(axe1.ztnblist),ncol=13,byrow=T)
axe1.ztnb<-apply(axe1.ztnbmatrix,1,function(x) x/sqrt(sum(x^2)))
a5<-rowSums(axe1.ztnb)/1000
a5.sd<-apply(axe1.ztnb,1,sd)
zoal<-cbind(a4,a1,a2,a3,b4,b1,b2,b3)
xtable(zoal,digits=4)

####################
###simulation 5.3###
####################
rm(list=ls())
setwd('...')
library(VGAM)
library(snowfall)
data(hspider)
hs.ev<-hspider[,1:6]
hs.ab.raw<-as.matrix(hspider[,7:18])

#restult from CCA
grad1<-c(-.51,.33,-.14,.05,-.28,.27)
grad2<-c(-.41,-.10,.37,-.27,-.15,-.03)

#
#sfInit(parallel=TRUE,cpus=2)
library(logistf)
load('sitescore.Rda')
spName<-colnames(hs.ab.raw)
coolcol<-c('antiquewhite4','red','lightpink','blue','blueviolet','yellow','darkgreen','magenta','coral','cornflowerblue','cyan','darkkhaki')
#original data

tolerance<-1e-4
or1.p<-nlm(LR_pois,grad1,sp.new=hs.ab.raw,envar=hs.ev,steptol=tolerance,gradtol=tolerance)$estimate#1st grad
or1.t<-nlm(LR,grad1,sp=hs.ab.raw,envar=hs.ev,TYPE='pps',steptol=tolerance,gradtol=tolerance)$estimate
org1.p<-or1.p/sqrt(sum(or1.p^2))
org1.t<-or1.t/sqrt(sum(or1.t^2))
sitescore1.p<-as.matrix(hs.ev)%*%org1.p
sitescore1.t<-as.matrix(hs.ev)%*%org1.t
res1<-apply(hs.ev,2,function(x) lm(x~sitescore1.p+I(sitescore1.p^2))$residuals)
res2<-apply(hs.ev,2,function(x) lm(x~sitescore1.t+I(sitescore1.t^2))$residuals)
or2.p<-nlm(LR_pois,grad2,sp.new=hs.ab.raw,envar=res1,steptol=tolerance,gradtol=tolerance)$estimate
or2.t<-nlm(LR,grad2,sp=hs.ab.raw,envar=res2,TYPE='pps',steptol=tolerance,gradtol=tolerance)$estimate

org2.p<-or2.p/sqrt(sum(or2.p^2))
org2.t<-or2.t/sqrt(sum(or2.t^2))
sitescore2.p<-res1%*%org2.p
sitescore2.t<-res2%*%org2.t

save(org1.p,org1.t,org2.p,org2.t,sitescore1.p,sitescore1.t,sitescore2.p,sitescore2.t,file='~/Dropbox/spider/sitescore.Rda')

orgcf1.p<-apply(hs.ab.raw,2,function(x) glm(x~sitescore1.p+I(sitescore1.p^2),family=poisson())$coefficients)
orgcf1.t<-apply(hs.ab.raw,2,function(x) ZT_posnegb(x,sitescore1.t,model='pps')$coefficients)
orgcf2.p<-apply(hs.ab.raw,2,function(x) glm(x~sitescore2.p+I(sitescore2.p^2),family=poisson())$coefficients)
orgcf2.t<-apply(hs.ab.raw,2,function(x) ZT_posnegb(x,sitescore2.t,model='pps')$coefficients)

mm1.p<-apply(orgcf1.p,2,function(x) -x[2]/(2*x[3]))
mm2.p<-apply(orgcf2.p,2,function(x) -x[2]/(2*x[3]))
mm1.t<-apply(orgcf1.t,2,function(x) -x[2]/(2*x[3]))
mm2.t<-apply(orgcf2.t,2,function(x) -x[2]/(2*x[3]))

names(org1.p)<-c('WC','BS','FT','CM','CH','RL')
names(org1.t)<-c('WC','BS','FT','CM','CH','RL')
names(org2.p)<-c('WC','BS','FT','CM','CH','RL')
names(org2.t)<-c('WC','BS','FT','CM','CH','RL')


#ordination diagram
pdf(file='~/Desktop/0p.pdf')
mybiplot(cbind(sitescore1.p,sitescore2.p),cbind(org1.p,org2.p),cbind(mm1.p,mm2.p),spName,col=c('black','blue'),col2=coolcol,cex=c(0.6,0.8),arrow.len=0.05,xlab='1st environmental gradient',ylab='2nd environmental gradient',main='Poisson',ylim=c(-3,3),xlim=c(-5,8))
dev.off()

pdf(file='~/Desktop/0t.pdf')
mybiplot(cbind(sitescore1.t,sitescore2.t),cbind(org1.t,org2.t),cbind(mm1.t,mm2.t),spName,cex=c(0.6,0.8),arrow.len=0.05,xlab='1st environmental gradient',ylab='2nd environmental gradient',main='HZTP',ylim=c(-3,3),xlim=c(-5,8))
dev.off()

#gradually change the abundance Trocterr
HS<-hs.ab.raw
target<-HS[,11]
i<-1
ab.list<-list()

#abundance by step
while(sum(target!=0)>3){
    temp<-min(target[target>0])
	target[target==temp]=0
	HS[,11]<-target
	ab.list[[i]]<-HS
	cat(i)
	i<-i+1
	}
	length(which(hs.ab.raw[,11]==0))
		length(which(ab.list[[17]][,11]==0))
#LRR-P
out<-list()
grad<-list()
for (i in 1:17){
grad[[1]]<-grad1
out[[i]]<-nlm(LR_pois,grad[[i]],sp.new=ab.list[[i]],envar=hs.ev)
grad[[i+1]]<-out[[i]]$estimate
}
#LRR-ZTP
outt<-list()
gradd<-list()
for (i in 1:17){
gradd[[1]]<-grad1
outt[[i]]<-nlm(LR,gradd[[i]],sp=ab.list[[i]],envar=hs.ev,TYPE='pps')
gradd[[i+1]]<-outt[[i]]$estimate
}

#extract the gradients
grad<-grad[-1]
gradd<-gradd[-1]
gP<-matrix(unlist(grad),nrow=17,ncol=6,byrow=TRUE)
gT<-matrix(unlist(gradd),nrow=17,ncol=6,byrow=TRUE)
glp<-apply(gP,1, function(x) x/sqrt(sum(x^2)))
glt<-apply(gT,1, function(x) x/sqrt(sum(x^2)))

#save the data
lp<-glp
lt<-glt
save(lp,lt,file='/Users/yingjiezhang/Dropbox/Story_of_many_0s/SimulationGraph/spider/lpt.Rda')

#first site score for Poisson model and ZTP model
zz1.p<-as.matrix(hs.ev)%*%lp
zz1.t<-as.matrix(hs.ev)%*%lt

res.p<-list()
res.t<-list()

#Obtain the residuals
for(i in 1:17){
res.p[[i]]<-apply(hs.ev,2,function(x) lm(x~zz1.p[,i]+I(zz1.p[,i]^2))$residuals)
res.t[[i]]<-apply(hs.ev,2,function(x) lm(x~zz1.t[,i]+I(zz1.t[,i]^2))$residuals)
}


#LRR-P for 2nd gradient
out2<-list()
gradp<-list()

for (i in 1:17){
gradp[[1]]<-grad2
  out2[[i]]<-nlm(LR_pois,gradp[[i]],sp.new=ab.list[[i]],envar=res.p[[i]])
   gradp[[i+1]]<-out2[[i]]$estimate
}


#LRR-ZTP for 2nd gradient
  outt2<-list()
  gradd2<-list()
for (i in 1:17){
  gradd2[[1]]<-c(-1145.365693,-762.036193,550.218979,202.852823,1.938751,86.571470)
  outt2[[i]]<-nlm(LR,gradd2[[i]],sp=ab.list[[i]],envar=res.t[[i]],TYPE='pps')
    gradd2[[i+1]]<-outt2[[i]]$estimate
}

#obtain the second gradient
LLRP2<-list()
LLRT2<-list()

#modify the problematic one	

	
#	LT22<-lapply(gradp[-1],function(x) x$estimate)
#	LP22<-lapply(gradd2[-1],function(x) x$estimate)
  
    
   
    
    LP2<-matrix(unlist(gradp[-1]),nrow=17,ncol=6,byrow=TRUE)
    LT2<-matrix(unlist(gradd2[-1]),nrow=17,ncol=6,byrow=TRUE)
	
    lp2<-apply(LP2,1, function(x) x/sqrt(sum(x^2)))
    lt2<-apply(LT2,1, function(x) x/sqrt(sum(x^2)))
    
   
    save(lp2,lt2,file='/Users/yingjiezhang/Dropbox/Story_of_many_0s/SimulationGraph/spider/lpt2.Rda')	
	
    zz2.p<-matrix(NA,nrow=28,ncol=17)
    zz2.t<-matrix(NA,nrow=28,ncol=17)
    for (i in 1:17){
    	zz2.p[,i]<-res.p[[i]]%*%lp2[,i]
    	zz2.t[,i]<-res.t[[i]]%*%lt2[,i]
    	}
    	     	
rownames(lp)<-c('WC','BS','FT','CM','CH','RL')
rownames(lt)<-c('WC','BS','FT','CM','CH','RL')
rownames(lp2)<-c('WC','BS','FT','CM','CH','RL')
rownames(lt2)<-c('WC','BS','FT','CM','CH','RL')

#measurement of the departure
#coefficients saved in the array
	
    coef1.p<-array(NA,c(3,12,17))
    coef1.t<-array(NA,c(3,12,17))
    coef2.p<-array(NA,c(3,12,17))	
    coef2.t<-array(NA,c(3,12,17))
    for(j in 1:17){
      coef1.p[,,j]<-apply(ab.list[[j]],2,function(x) glm(x~zz1.p[,j]+I(zz1.p[,j]^2),family=poisson())$coefficients)
    	coef1.t[,,j]<-apply(ab.list[[j]],2,function(x) ZT_posnegb(x,zz1.t[,j],model='pps')$coefficients)
    	coef2.p[,,j]<-apply(ab.list[[j]],2,function(x) glm(x~zz2.p[,j]+I(zz2.p[,j]^2),family=poisson())$coefficients)
    	coef2.t[,,j]<-apply(ab.list[[j]],2,function(x) ZT_posnegb(x,zz2.t[,j],model='pps')$coefficients)
    	}	

#function to calculate the optimum
max.total<-function(s,cf1.p,cf2.p,cf1.t,cf2.t){
max1.p<-apply(cf1.p[,,s],2,function(x) -x[2]/(2*x[3]))
max2.p<-apply(cf2.p[,,s],2,function(x) -x[2]/(2*x[3]))
max1.t<-apply(cf1.t[,,s],2,function(x) -x[2]/(2*x[3]))
max2.t<-apply(cf2.t[,,s],2,function(x) -x[2]/(2*x[3]))
return(cbind(max1.p,max2.p,max1.t,max2.t))
		}

#departure measurement

max.total(1,coef1.p,coef2.p,coef1.t,coef2.t)
dis.p<-matrix(nrow=12,ncol=16)
disp.1<-matrix(nrow=12,ncol=16)
disp.2<-matrix(nrow=12,ncol=16)
#departure for LRR-ZTP method  
dis.t<-matrix(nrow=12,ncol=16)
dist.1<-matrix(nrow=12,ncol=16)
dist.2<-matrix(nrow=12,ncol=16)
for (j in 1:16){
  for (i in 1:12){
    
    #distance calculation
    dist.1[i,j]<-(max.total(j,coef1.p,coef2.p,coef1.t,coef2.t)[i,3]-mm1.t[i])^2
    dist.2[i,j]<-(max.total(j,coef1.p,coef2.p,coef1.t,coef2.t)[i,4]-mm2.t[i])^2
  }
  
}
####

for (j in 1:16){
	for (i in 1:12){
		
	#distance calculation
	
	disp.1[i,j]<-(max.total(j,coef1.p,coef2.p,coef1.t,coef2.t)[i,1]-mm1.p[i])^2
	disp.2[i,j]<-(max.total(j,coef1.p,coef2.p,coef1.t,coef2.t)[i,2]-mm2.p[i])^2
	#dis.p[i,j]<-sqrt(disp.1+disp.2)
		}
	
	}

#seperature departure of each species	

dp<-colSums(sqrt(disp.1+disp.2))
dt<-colSums(sqrt(dist.1+dist.2))
depar<-cbind(temp,dp,dt)

pdf(file='~/Desktop/departure3.pdf')
barplot(t(depar),beside=TRUE,col=c('red','blue','darkgray'),axis.lty=1,xlab='Step',ylab='Distance',main='The total distance')
legend('topleft',c('CCA','Poisson','HZTP'),fill=c('red','blue','darkgray'))
dev.off()

sq.disp1<-sqrt(disp.1)
	sq.dist1<-sqrt(dist.1)
    sq.disp2<-sqrt(disp.2)
    sq.dist2<-sqrt(dist.2)
    
pdf(file='departureN3.pdf')
ctr<-max(sq.disp2)	
plot(sq.disp2[1,],ylim=c(0,5),xlab='Step',ylab='Distance',main='Departure in 2nd Dimension (LRR-P)')
lines(sq.disp2[1,],lty=1)
for(i in 2:12){
	points(sq.disp1[i,],pch=i)
	lines(sq.disp1[i,],lty=i)
	}
#legend(0.5, 3.0, spName, lty=1:12,
#       pch = 1:12, ncol = 4, cex = 0.8)
	dev.off()
	
pdf(file='departureN2.pdf')		
ctr1<-max(sq.dist1)
plot(sq.dist1[1,],ylim=c(0,ctr1),,xlab='Step',ylab='Distance',main='Departure in 1st Dimension (LRR-ZTP)')
lines(sq.dist1[1,],lty=1)
for(i in 2:12){
	points(sq.dist1[i,],pch=i)
	lines(sq.dist1[i,],lty=i)
	}
#	legend(5, 1.5, spName, lty=1:12,
#       pch = 1:12, ncol = 4, cex = 0.8)
dev.off()
	
#total departure	
dis.p<-disp.1+disp.2
dis.t<-dist.1+dist.2
which(dist.1[12,]==max(dist.1[12,]))
	plot(dist.1[2,])
	plot(disp.1[2,])
	dis.t<-sqrt(dist.1+dist.2)
	dis.p<-sqrt(disp.1+disp.2)
  dis.c<-sqrt(temp)
colSums(dis.p)
colSums(dis.t)

departure1<-cbind(colSums(disp.1),colSums(dist.1))
departure2<-cbind(colSums(disp.2),colSums(dist.2))
departure3<-cbind(colSums(dis.p),colSums(dis.t),dis.c)

pdf(file='/Users/yingjiezhang/Dropbox/departure1.pdf')
barplot(t(departure1),beside=T,col=c('red','blue'),axis.lty=1,xlab='Step',ylab='Squart root of the deviation',main='The total deviation in the first dimension')
legend('topleft',c('Poisson','HZTP'),fill=c("red","blue"))
dev.off()
pdf(file='/Users/yingjiezhang/Dropbox/departure2.pdf')
barplot(t(departure2),beside=TRUE,col=c('red','blue'),axis.lty=1,xlab='Step',ylab='Squart root of the deviation',main='The total deviation in the second dimension')
legend('topleft',c('Poisson','HZTP','CCA'),fill=c("red","blue",'gray'))
dev.off()

pdf(file='~/Desktop/departure3.pdf')
barplot(t(departure3),beside=TRUE,col=c('grey','blue','red'),axis.lty=1,xlab='Step',ylab='Deviation',main='The total deviation')
legend('topleft',c('Poisson','HZTP','CCA'),fill=c("grey","blue",'red'))
dev.off()

#############
#section 6.3#
#############

library(VGAM)
library(snowfall)
data(hspider)
hs.ev<-hspider[,1:6]
hs.ab.raw<-as.matrix(hspider[,7:18])
hs.ab.bi<-ifelse(hs.ab.raw>0,1,0)
source('~/Dropbox/spider/Functions.R')
 #Yee 2004
 #rank one graph
rankZTP<-function(y){
	tem<-range(y)
	z<-seq(tem[1],tem[2],0.1)
	return(z)
	}
predd<-function(s,b,logit=T){
	temp<-b[1]+b[2]*s+b[3]*s^2
	if (logit) result<-temp
	else result<-exp(temp)/(1+exp(temp))
	return(result)
	}	
tolerance<-1e-4
grad.bi1<-c(-0.127,0.185,-0.498,0.228,-0.031,0.15)
hs.ev<-scale(hs.ev)
# initial value from Yee's result (2004)
# use exact logistic regression
lr1<-nlm(LR.binomial,estimate1,sp=hs.ab.bi,exact=T,envar=hs.ev,steptol=tolerance,gradtol=tolerance)
# result is listed below
#estimate1<-c(-1.1459601,0.2405881,-0.1513960,0.2473878,-0.1673378,0.4591572)
#ord.bi1<-estimate1/sqrt(sum(estimate1^2))
ord.bi1<-lr1$estimate/sqrt(sum(lr1$estimate^2))
s1<-as.matrix(hs.ev)%*%ord.bi1
bi.cef1<-apply(hs.ab.bi,2,function(x) logistf(x~s1+I(s1^2))$coefficient)
max1<-apply(bi.cef1,2,function(x) -x[2]/(2*x[3]))

#ordination diagram#
 
bi.res<-apply(hs.ev,2,function(x) lm(x~s1+I(s1^2))$residuals)
bi.res<-as.matrix(bi.res))
#delete the spiece that is not well quadratically performed.
# see binomial1.pdf
org2.t<-c(-0.79850716,-0.45042467,0.33140506,0.18600229,-0.03097379,0.11882081)
# withe3,5,7
lr2<-nlm(LR.binomial,org2.t,sp=hs.ab.bi,envar=bi.res,exact=T,steptol=1e-4,gradtol=1e-4)
lr3<-nlm(LR.binomial,org2.t,sp=hs.ab.bi,envar=bi.res,exact=T,steptol=1e-4,gradtol=1e-4)
# result
a2<-c(--7.145099  -8.674920  24.755574 -14.745223  -7.961853  -5.974385)
a3<-c(-0.7817780,-3.4298313,29.8585861,-0.4728115,0.3861377,1.5659994)
estimate2<-c(-5.085191,-7.228277,23.747855,-4.228515,-2.808287,1.79105)
ord.bi3<-lr3$estimate/sqrt(sum(lr3$estimate^2))
ord.bi2.1<-lr2$estimate/sqrt(sum(lr2$estimate^2))
  2<-as.matrix(bi.res)%*%ord.bi2.1
  s3<-as.matrix(bi.res)%*%ord.bi3
s2.2<-bi.res%*%ord.bi2.2
 score2<-bi.res%*%a3
bi.cef2<-apply(hs.ab.bi,2,function(x)  logistf(x~s2+I(s2^2))$coefficients)
bi.cef3<-apply(hs.ab.bi,2,function(x)  logistf(x~s3+I(s3^2))$coefficients)

interval<-rankZTP(s2)
coolcol<-c('antiquewhite4','red','lightpink','blue','blueviolet','yellow','darkgreen','magenta','coral','cornflowerblue','cyan','darkkhaki')
pdf(file='binomial1.pdf')	
op<-par(mfrow=c(3,4),pty='s')
par('mfrow')
   for(i in 1:12){
   plot(s1,type='n',cex=0.8,xlim=range(s1),ylim=c(-1,1),xlab='Environmental gradient',ylab='logit p')
   mtext(colnames(hs.ab.bi)[i])
  lines(interval,predd(interval,bi.cef2.1[,i],logit=T),lty=1,col=coolcol[i])
}
dev.off()

max3<-apply(bi.cef3,2,function(x) -x[2]/(2*x[3]))
#####
names(ord.bi1)<-c('WC','BS','FT','CM','CH','RL')
names(ord.bi3)<-c('WC','BS','FT','CM','CH','RL')
names(org2.p)<-c('WC','BS','FT','CM','CH','RL')
names(org2.t)<-c('WC','BS','FT','CM','CH','RL')

spName<-colnames(hs.ab.bi)
pdf('~/Desktop/binomialBW.pdf')	
mybiplot(cbind(s1,s3),cbind(ord.bi1,ord.bi3),cbind(max1,max3),spName,col=c('black','blue'),col2=coolcol,cex=c(0.6,0.8),arrow.len=0.05,xlab='1st environmental gradient',ylab='2nd environmental gradient',main='Absence/Presence model',ylim=c(-1.5,1.5),xlim=c(-4,4))
dev.off()
